ALTER TABLE t_question ADD COLUMN sum_attach_file_capacity bigint;
ALTER TABLE t_question ADD COLUMN guest_name varchar(512);
ALTER TABLE t_question ADD COLUMN guest_e_mail varchar(256);
ALTER TABLE t_question ADD COLUMN guest_info_mail char(1) DEFAULT '0';
ALTER TABLE t_question ADD COLUMN guest_pass varchar(64);
ALTER TABLE t_question ADD COLUMN question_upd_user_id bigint;
ALTER TABLE t_question ADD COLUMN question_upd_date timestamp;
COMMENT ON COLUMN t_question.sum_attach_file_capacity IS '添付ファイルの合計容量';
COMMENT ON COLUMN t_question.guest_name IS '外部ユーザー用名前';
COMMENT ON COLUMN t_question.guest_e_mail IS '外部ユーザー用名前メールアドレス';
COMMENT ON COLUMN t_question.guest_info_mail IS '外部ユーザー用メール通知';
COMMENT ON COLUMN t_question.guest_pass IS '外部ユーザー用認証用パスワード';
COMMENT ON COLUMN t_question.question_upd_user_id IS '質問内容更新ユーザーID';
COMMENT ON COLUMN t_question.question_upd_date IS '質問内容更新日時';
update t_question set sum_attach_file_capacity = 0;
update t_question set sum_attach_file_capacity = tqaf.sum_attach_file_capacity FROM (select q_id,sum(attach_file_capacity) as sum_attach_file_capacity from t_question_attachment_file group by q_id) tqaf WHERE t_question.q_id = tqaf.q_id;
ALTER TABLE t_answer ADD COLUMN sum_attach_file_capacity bigint;
ALTER TABLE t_answer ADD COLUMN answer_upd_user_id bigint;
ALTER TABLE t_answer ADD COLUMN answer_upd_date timestamp;
ALTER TABLE t_answer ADD COLUMN supplement_upd_user_id bigint;
ALTER TABLE t_answer ADD COLUMN supplement_upd_date timestamp;
ALTER TABLE t_answer ADD COLUMN thank_upd_user_id bigint;
ALTER TABLE t_answer ADD COLUMN thank_upd_date timestamp;
COMMENT ON COLUMN t_answer.sum_attach_file_capacity IS '添付ファイルの合計容量';
COMMENT ON COLUMN t_answer.answer_upd_user_id IS '回答更新ユーザーID';
COMMENT ON COLUMN t_answer.answer_upd_date IS '回答更新日時';
COMMENT ON COLUMN t_answer.supplement_upd_user_id IS '補足更新ユーザーID';
COMMENT ON COLUMN t_answer.supplement_upd_date IS '補足更新日時';
COMMENT ON COLUMN t_answer.thank_upd_user_id IS 'お礼更新ユーザーID';
COMMENT ON COLUMN t_answer.thank_upd_date IS 'お礼更新日時';
update t_answer set sum_attach_file_capacity = 0;
update t_answer set sum_attach_file_capacity = taaf.sum_attach_file_capacity FROM (select q_id,a_id,sum(attach_file_capacity) as sum_attach_file_capacity from t_answer_attachment_file group by q_id,a_id) taaf WHERE t_answer.q_id = taaf.q_id and t_answer.a_id = taaf.a_id;
ALTER TABLE m_category ADD COLUMN name_view_flg char(1) DEFAULT '0';
COMMENT ON COLUMN m_category.name_view_flg IS '質問・回答者名表示フラグ';
delete from t_setting where set_name = 'LIMIT_IMG_UPLOAD';
INSERT INTO t_setting (set_name,set_value,set_information,set_flg) VALUES ('LIMIT_ATTACHE_FILE_SIZE_MAX','1','1ファイルあたりの最大サイズ',1);
INSERT INTO t_setting (set_name,set_value,set_information,set_flg) VALUES ('LIMIT_ATTACHE_FILE_WIDTH_MAX','600','アップロード画像ファイルの最大幅',1);
INSERT INTO t_setting (set_name,set_value,set_information,set_flg) VALUES ('DEF_ATTACHE_FILE_ALLOW_EXTENSION','txt,htm,html,doc,docx,dot,pdf,xlt,xls,xlsx,ppt,pptx,vsd,vss,vst,vsw,jaw,jbw,jfw,gif,jpg,jpeg,png,bmp,zip,lzh,pps,ps,ai,eps,pjpeg,jpe,rtf,csv','アップロード許可拡張子',0);
update t_setting set set_value='12' ,set_flg = '1' where set_name = 'LIMIT_ATTACHE_FILE_SUM_SIZE' ;
INSERT INTO t_setting (set_name,set_value,set_information,set_flg) VALUES ('DEF_HTTP_HOST','http://localhost','httpホスト',1);
INSERT INTO t_setting (set_name,set_value,set_information,set_flg) VALUES ('DEF_PASSWORD_REQUIRED','1','パスワードの必須入力',4);
INSERT INTO t_setting (set_name,set_value,set_information,set_flg) VALUES ('DEF_PASSWORD_LENGTH_MIN','','パスワードの最小文字数',4);
INSERT INTO t_setting (set_name,set_value,set_information,set_flg) VALUES ('DEF_PASSWORD_INVALID_CHAR','','パスワードの禁止文字',4);
CREATE TABLE t_libura_login_info(authentication_key varchar(32), user_id bigint, login_id varchar(1024), word varchar(1024), regist_date timestamp);
ALTER TABLE t_libura_login_info ADD PRIMARY KEY ( authentication_key);
COMMENT ON TABLE t_libura_login_info IS 'liburaログイン入力省略情報';
COMMENT ON COLUMN t_libura_login_info.authentication_key IS '認証キー';
COMMENT ON COLUMN t_libura_login_info.user_id IS 'ユーザーID';
COMMENT ON COLUMN t_libura_login_info.login_id IS 'liburaID（メールアドレス)';
COMMENT ON COLUMN t_libura_login_info.word IS 'パスワード';
COMMENT ON COLUMN t_libura_login_info.regist_date IS '登録日時';
ALTER TABLE m_category ALTER icon_image_type TYPE varchar(127);
ALTER TABLE t_question_attachment_file ALTER attach_file_type TYPE varchar(127);
ALTER TABLE t_answer_attachment_file ALTER attach_file_type TYPE varchar(127);
ALTER TABLE t_setting_file ALTER set_mime TYPE varchar(127);
update t_setting set set_value='200204' where set_name = 'DEF_SYS_VERSION';
update t_setting set set_value='V2.0J_R2.4' where set_name = 'DEF_SYS_VERSION_NAME';