#!/bin/sh
# ------------------------------------------------------------------------------
#   convert
# ------------------------------------------------------------------------------
# ------------------------------------------------------------------------------
# 値設定
# ------------------------------------------------------------------------------
# オリジナルカレントディレクトリ取得
OG_DIR=${PWD}
export OG_DIR
# 実行ファイルディレクトリ取得
SH_DIR=`dirname $0`
export SH_DIR
# 実行ファイルディレクトリ移動
cd ${SH_DIR}
# 移動後のディレクトリ保存(batch\binディレクトリのパスを記述)
BASEDIR=${PWD}
# 設定ファイル読込
. $BASEDIR/common.sh
# ERRLEVELを保存
ERRLVL="INFO"
# PATH設定
PATH=$PHPDIR:${PATH}:
export PATH
# PHP(CLI)のパスを保存
PHPPATH=`which php`

# ------------------------------------------------------------------------------
# 変数記述チェック
# ------------------------------------------------------------------------------
if [ -z $BASEDIR ]; then
    echo シェルを修正しBASEDIRを設定してください。
    exit -1
fi

if [ -z $PHPPATH ]; then
    echo シェルを修正しPHPPATHを設定してください。
    exit -2
fi

# ------------------------------------------------------------------------------
# コンバート処理開始
# ------------------------------------------------------------------------------
cd $BASEDIR
cd ../actions/Convert

# ------------------------------------------------------------------------------
# 更新処理
# ------------------------------------------------------------------------------
$PHPPATH ./Update.php
ERROR_NO1=$?
if [ $ERROR_NO1 = 1 ]; then
    echo 処理中にエラーが発生しました。
    exit 1
fi
if [ ! $ERROR_NO1 = 0 ]; then
    echo ログファイルの作成に失敗しました。
    exit 2
fi

# ------------------------------------------------------------------------------
# 呼び出し元に戻る
# ------------------------------------------------------------------------------
# オリジナルカレントディレクトリ移動
cd ${OG_DIR}
