<?php
//------------------------------------------------------------------------------
//--                                                                          --
//--    FILE NAME :  Batch.class.php                                          --
//--                                                                          --
//--        Designed by NeoJapan   2005-12-02   Ver. 1.00                     --
//--        Coded    by NeoJapan   2005-12-02   Ver. 1.00                     --
//--        Revised  by XXXXXXXXX  XXXX-XX-XX   Ver. X.00                     --
//--                                                                          --
//------------------------------------------------------------------------------
//--   (C)COPYRIGHT 2005 BY NeoJapan CORPORATION ALL RIGHTS RESERVED          --
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// 󥯥롼
//------------------------------------------------------------------------------
require_once(LOGGING_DIR .  'FileAppender.class.php');
require_once(ADODB_DIR .    'adodb.inc.php');
require_once(FILTER_DIR .   'ADODBConnectionFilter.class.php');

//------------------------------------------------------------------------------
// 
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//--    饹 Batch                                                        --
//--    Class  Batch                                                        --
//------------------------------------------------------------------------------
//--  MODIFIED        YYYY-MM-DD REV    - NOTES                               --
//--  NEOJAPAN        2005-12-02 1.00   - CREATE NEW                          --
//------------------------------------------------------------------------------
/**
 * Хåδʬ
 *     : ХåϤѾ
 *     : php4.3.0ʹ
 */
class Batch
{
    // ХåȤƵưå롣
    var $checkExecutedAsBatch = false;

    //--------------------------------------------------------------------------
    // 󥹥󥹥᥽å
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    //--    ؿ̾ ư                                                 --
    //--    Method bm_Activate()                                            --
    //--------------------------------------------------------------------------
    //--  MODIFIED        YYYY-MM-DD REV    - NOTES                           --
    //--  NEOJAPAN        2005-12-02 1.00   - CREATE NEW                      --
    //--------------------------------------------------------------------------
    /**
     * Хåư롣
     *
     * @param  bool    Ȥtrue
     */
    function bm_Activate($action_name = '')
    {
        //[ ưΥå ]
        if ($this->checkExecutedAsBatch && isset($_SERVER['HTTP_HOST']) && $_SERVER['HTTP_HOST'])
        {
            trigger_error('fatal error.', E_USER_ERROR);
            return false;
        }

        // 
        $logger = $this->rm_getLogger($action_name);
        if (!is_object($logger))
        {
            trigger_error('get logger error.', E_USER_ERROR);
            return false;
        }

        // ǡ١³
        $db = $this->rm_getDB();
        if (!is_object($db))
        {
            $this->rm_Finish($db, $logger, $db);
            return false;
        }

        // 
        $ret = $this->rm_Initialize($db, $logger);
        if ( (is_bool($ret) && $ret === false) ||
             (is_int($ret)  && $ret !== 0 ) )
        {
            $this->rm_Finish($db, $logger, $ret);
            return false;
        }

        // Ƚ
        $ret = $this->rm_Validate($db, $logger);
        if ( (is_bool($ret) && $ret === false) ||
             (is_int($ret)  && $ret !== 0 ) )
        {
            $this->rm_Finish($db, $logger, $ret);
            return false;
        }

        // 
        $ret = $this->rm_Execute($db, $logger);
        if ( (is_bool($ret) && $ret === false) ||
             (is_int($ret)  && $ret !== 0 ) )
        {
            $this->rm_Finish($db, $logger, $ret);
            return false;
        }

        $this->rm_Finish($db, $logger, $ret);
        return true;
    }

    //--------------------------------------------------------------------------
    //--    ؿ̾ DB                                                   --
    //--    Method rm_getDB()                                               --
    //--------------------------------------------------------------------------
    //--  MODIFIED        YYYY-MM-DD REV    - NOTES                           --
    //--  NEOJAPAN        2005-12-02 1.00   - CREATE NEW                      --
    //--------------------------------------------------------------------------
    /**
     * DB
     *
     * @return object  DB֥
     */
    function rm_getDB()
    {
        //ADOdb
        $GLOBALS["ADODB_CACHE_DIR"] = ADODB_CACHE_DIR;

        $DB = NewADOConnection(SQL_TYPE);
        $DB->debug = ADODB_DEBUG;    //ǥХå
        $DB->cacheSecs = ADODB_CACHE_SECS; //åͭ

        //³
        if( defined('SQL_PORT') ){
            $ok = $DB->Connect(SQL_SERVER.':'.SQL_PORT, SQL_USER , SQL_PASSWORD, SQL_DATABASE);
        }else{
            $ok = $DB->Connect(SQL_SERVER, SQL_USER , SQL_PASSWORD, SQL_DATABASE);
        }
        if(!$ok) {
            //顼ȯ硢
            return FALSE;
        }

        // λClose¹Ԥ褦Ͽ
        register_shutdown_function(array(&$DB, 'Close'));

        return $DB;
    }

    //--------------------------------------------------------------------------
    //--    ؿ̾ 顼                                           --
    //--    Method rm_getLogger()                                           --
    //--------------------------------------------------------------------------
    //--  MODIFIED        YYYY-MM-DD REV    - NOTES                           --
    //--  NEOJAPAN        2005-12-02 1.00   - CREATE NEW                      --
    //--------------------------------------------------------------------------
    /**
     * 顼
     *
     * @param  string  action_name [IN]:̾
     * @return object  Logger֥
     */
    function rm_getLogger($action_name)
    {
        // Ϸ
        $layout = & new PatternLayout(STR_ERRORLOG_LAYOUT);
        // 
        $appender =& new FileAppender($layout
          , BATCH_DIR . 'logs' . DIRECTORY_SEPARATOR
           . $action_name .'_'. STR_ERRORLOG_PREFIX . '_%d{Y_m_d}.log');
        // ϸ
        $logger = new ErrorLogger();
        $logger->setExitPriority(LEVEL_FATAL);
        $logger->setPriority(LEVEL_WARN);
        $logger->addAppender('file', $appender);

        return $logger;
    }

    //--------------------------------------------------------------------------
    //--    ؿ̾                                                  --
    //--    Method rm_Initialize()                                          --
    //--------------------------------------------------------------------------
    //--  MODIFIED        YYYY-MM-DD REV    - NOTES                           --
    //--  NEOJAPAN        2005-12-02 1.00   - CREATE NEW                      --
    //--------------------------------------------------------------------------
    /**
     * 򤹤롣
     *
     * @param  object  &$db        [I/O]:DB֥
     * @param  object  &$logger    [I/O]:֥
     * @return bool    Ȥtrue
     */
    function rm_Initialize(&$db, &$logger)
    {
        return true;
    }

    //--------------------------------------------------------------------------
    //--    ؿ̾ Ƚ                                                 --
    //--    Method rm_Validate()                                            --
    //--------------------------------------------------------------------------
    //--  MODIFIED        YYYY-MM-DD REV    - NOTES                           --
    //--  NEOJAPAN        2005-12-02 1.00   - CREATE NEW                      --
    //--------------------------------------------------------------------------
    /**
     * Ƚ򤹤롣
     *
     * @param  object  &$db        [I/O]:DB֥
     * @param  object  &$logger    [I/O]:֥
     * @return bool    ȤƤȤtrueͤȤfalse
     */
    function rm_Validate(&$db, &$logger)
    {
        return true;
    }

    //--------------------------------------------------------------------------
    //--    ؿ̾                                                    --
    //--    Method rm_Execute()                                             --
    //--------------------------------------------------------------------------
    //--  MODIFIED        YYYY-MM-DD REV    - NOTES                           --
    //--  NEOJAPAN        2005-12-02 1.00   - CREATE NEW                      --
    //--------------------------------------------------------------------------
    /**
     * 򤹤롣
     *
     * @param  object  &$db        [I/O]:DB֥
     * @param  object  &$logger    [I/O]:֥
     * @return bool    Ȥtrue
     */
    function rm_Execute(&$db, &$logger)
    {
        return true;
    }

    //--------------------------------------------------------------------------
    //--    ؿ̾λ                                                  --
    //--    Method rm_Finish()                                              --
    //--------------------------------------------------------------------------
    //--  MODIFIED        YYYY-MM-DD REV    - NOTES                           --
    //--  NEOJAPAN        2005-12-02 1.00   - CREATE NEW                      --
    //--------------------------------------------------------------------------
    /**
     * λɬפʽ
     * ｪλ۾ｪλ˴ؤ餺ƤФ롣
     *
     * @param  object  &$db        [I/O]:DB֥
     * @param  object  &$logger    [I/O]:֥
     * @param  string  $retval     [ I ]:ν
     */
    function rm_Finish(&$db, &$logger, $retval)
    {
    }
}
?>