<?php
define('PREFIX_DBVALUE', 'dbval_');
define("AUTO_LANG", false);
define("DEFAULT_LANG", "ja");

/**
 * åΤΥե륿
 * LocalMessage::bm_getMsg($request, )Ǽ롣
 *
 * @access public
 */
class MessageFilter extends Filter {

    /**
     * åɤ߹ߡϿ¹Ԥ롣
     *
     * @param FilterChain  &$filterChain [I/O]:mojavi Filter Chain
     * @param Controler    &$controller  [I/O]:mojavi Controler
     * @param Request      &$request     [I/O]:mojavi Request
     * @param User         &$user        [I/O]:mojavi User
     */
    function execute (&$filterChain, &$controller, &$request, &$user) {
        $messages = array();

        // μ
        if( $user->hasAttribute("language", "org.mojavi.filter.MessageFilter") ){
            $lang = $user->getAttribute("language", "org.mojavi.filter.MessageFilter");
        }else if(AUTO_LANG){
            $lang = MessageFilter::getLocale();
        }else{
            $lang = DEFAULT_LANG;
        }

        // ̸եɤ߹
        if( is_readable(BASE_DIR."config/messages_$lang.ini") ){
            $globalMessagesPath = BASE_DIR."config/messages_$lang.ini";
        }else{
            $globalMessagesPath = BASE_DIR."config/messages_".DEFAULT_LANG.".ini";
        }

        // ⥸塼뤴Ȥθեɤ߹
        if( is_readable($controller->getModuleDir()."config/messages_$lang.ini") ){
            $messagesPath = $controller->getModuleDir()."config/messages_$lang.ini";
        }else{
            $messagesPath = $controller->getModuleDir()."config/messages_".DEFAULT_LANG.".ini";
        }

        // global messages
        if ($request->hasAttribute("messages") === false) {
            if (is_readable($globalMessagesPath)){
                $messages = parse_ini_file($globalMessagesPath);
            }
        }
        else {
            $messages = $request->getAttribute("messages");
        }

        // module messages
        if (is_readable($messagesPath)){
            $messages = array_merge($messages, parse_ini_file($messagesPath));
        }

        // DBͤμ
        $DBval    = array();
        $length   = strlen(PREFIX_DBVALUE);

        foreach($messages as $id => $message){
            //[ ƬȽ ]
            if (PREFIX_DBVALUE == substr($id, 0, $length)){
                $lastSep = strrpos($id, '_');
                //[ DBͤΥȽ ]
                if ($lastSep > $length){
                    $columnID = substr($id, $length, $lastSep - $length);
                    // ͤ
                    $columnValue = substr($id, $lastSep + 1);
                    $DBval[$columnID][$columnValue] = $message;
                }
            }
        }

        // 
        /// @see    sessionؤ°¸
        ///         - messages
        ///         - array
        ///         - å
        ///         - Ϣ
        $request->setAttribute("messages", $messages);

        // 
        /// @see    sessionؤ°¸
        ///         - dbValue
        ///         - array
        ///         - ǡ١ɽ
        ///         - 2
        $request->setAttribute('dbValue', $DBval);

        $filterChain->execute($controller, $request, $user);
    }

    /**
     * ʸ롣
     *
     * @return string  ʸ
     */
    function getLocale() {
        return array_shift(MessageFilter::getLocales());
    }

    /**
     * ʸƼ롣
     *
     * @return array   ʸ
     */
    function getLocales() {
        foreach (array_reverse(split(",", $_SERVER["HTTP_ACCEPT_LANGUAGE"])) as $value) {
            list($name, $pri) = split(";", trim($value));
            $num = preg_replace("/^q=/", "", $pri);
            $langs[$num ? $num : 1] = $name;
        }
        arsort($langs, SORT_NUMERIC);
        foreach ($langs as $value) {
            $locales[] = $value;
        }
        return $locales;
    }
}

/**
 * å롣
 *
 */
class LocalMessage {

    /**
     * ̥å
     *
     * @param    $request       Request             mojaviꥯȥ֥
     * @param    $name          String              ̾
     * @return   String         ʸ
     */
    function bm_getMsg (&$request, $name)
    {
        // Ƹʸ
        $messages = $request->getAttribute("messages");
        // бʸʤ硢Τ֤
        if( empty($messages) || !is_array($messages) || empty($messages[$name])){
            return $name;
        }
        return $messages[$name];
    }
}
?>