//
// don't forget to read common.js file before reading this source code.
// don't forget to read widget_func.js file before reading this source code.
//

$(function(){
    // click recent_tab event
    $('#recent_tab').click(function(){
        clear_tab('#recent');
        clear_tab('#useful');
        clear_tab('#view');
        activate_tab( '#recent' );
        change_list(1, '#list');
    });
    // click useful_tab event
    $('#useful_tab').click(function(){
        clear_tab('#recent');
        clear_tab('#useful');
        clear_tab('#view');
        activate_tab( '#useful' );
        change_list(2, '#list');
    });
    // click popular_tab event
    $('#view_tab').click(function(){
        clear_tab('#recent');
        clear_tab('#useful');
        clear_tab('#view');
        activate_tab( '#view' );
        change_list(3, '#list');
    });

    // click wait_myanswer_tab event
    $('#wait_myanswer_tab').click(function(){
        clear_tab('#wait_myanswer');
        clear_tab('#req_answer');
        clear_tab('#my_question');
        activate_tab( '#wait_myanswer' );
        change_list(1, '#mytab');
    });
    // click req_answer_tab event
    $('#req_answer_tab').click(function(){
        clear_tab('#wait_myanswer');
        clear_tab('#req_answer');
        clear_tab('#my_question');
        activate_tab( '#req_answer' );
        change_list(2, '#mytab');
    });
    // click my_question_tab event
    $('#my_question_tab').click(function(){
        clear_tab('#wait_myanswer');
        clear_tab('#req_answer');
        clear_tab('#my_question');
        activate_tab( '#my_question' );
        change_list(3, '#mytab');
    });
});

$(document).ready(function() {

    load_info_widget();

    var base_dir = $('#base_dir')[0].innerHTML;
    var base_url = base_dir + 'index.php';

    // display individual questions if the authentication to login is completed.
    var is_login = $('#top #top_login_info');
    if( is_login != undefined && is_login.length != 0 ) {

        // check tabs to activate at initial state
        var wait_myanswer_tab = $('#top #wait_myanswer_tab');
        var req_answer_tab = $('#top #req_answer_tab');
        var my_question_tab = $('#top #my_question_tab');

        // default values of activate tab(initialize data)
        var default_tab = '';
        var list_no    = 0;

        // approve tab alive ?
        if( wait_myanswer_tab != undefined && wait_myanswer_tab.length != 0 ) {
            // set default active tab
            set_active_tab( 1, '#wait_myanswer' );

            // get waiting answer to display
            $.ajax({
                url    : base_url + '?module=top&action=ajax_getWaitingAnswer',
                timeout: 30000 ,
                success: update_waiting_answer ,
                error  : waiting_answer_error
            });

        }
        // answer tab alive?
        if( req_answer_tab != undefined && req_answer_tab.length != 0 ) {
            // set default active tab
            set_active_tab( 2, '#req_answer' );

            // get requested answers to display
            $.ajax({
                url: base_url + '?module=top&action=ajax_getRequestedAnswer',
                timeout: 30000 ,
                success: update_requested_answer ,
                error  : requested_answer_error
            });

        }

        // if can't find other tab, set default active tab
        set_active_tab( 3, '#my_question' );

        // get my questions to display(display always)
        $.ajax({
            url: base_url + '?module=top&action=ajax_getMyQuestion',
            timeout: 30000 ,
            success: update_my_question ,
            error  : my_question_error
        });

        // activate tab
        activate_tab( default_tab );
        change_list( list_no, '#mytab' );

    }

    // get recent questions to display
    $.ajax({
        url    : base_url + '?module=top&action=ajax_getRecentQuestion',
        timeout: 30000 ,
        success: update_recent_question ,
        error  : recent_question_error
    });

    // get useful questions to display
    $.ajax({
        url    : base_url + '?module=top&action=ajax_getUsefulQuestion',
        timeout: 30000 ,
        success: update_useful_question ,
        error  : useful_question_error
    });

    // get popular questions to display
    $.ajax({
        url    : base_url + '?module=top&action=ajax_getPopularQuestion',
        timeout: 30000 ,
        success: update_popular_question ,
        error  : popular_question_error
    });

    // set default tab to activate
    function set_active_tab( no, tab ) {
        if( list_no == 0 ) {
            default_tab = tab;
            list_no     = no;
        }
    }

    /****** call back functions below *****/
    // call back function for updating waiting answer to approve
    function update_waiting_answer(data){
        $('#top #waiting_answer_inprogress').css( 'display', 'none' );
        $('#top #waiting_answer_done').css( 'display', 'block' );
        $('#top #waiting_answer_done').append( data );
    };
    // call back function for updating waiting answer to approve error handler
    function waiting_answer_error( XMLHttpRequest, status, errorThrown ){
        $('#top #waiting_answer_inprogress').css( 'display', 'none' );
        $('#top #waiting_answer_done').css( 'display', 'block' );
        var disp_string = gf_getAjaxListErrorString( XMLHttpRequest, status);
        $('#top #waiting_answer_done').append( disp_string );
    };

    // call back function for updating requested answers to approve
    function update_requested_answer(data){
        $('#top #requested_answer_inprogress').css( 'display', 'none' );
        $('#top #requested_answer_done').css( 'display', 'block' );
        $('#top #requested_answer_done').append( data );
    };
    // call back function for updating requested answers to approve error handler
    function requested_answer_error( XMLHttpRequest, status, errorThrown ){
        $('#top #requested_answer_inprogress').css( 'display', 'none' );
        $('#top #requested_answer_done').css( 'display', 'block' );
        var disp_string = gf_getAjaxListErrorString( XMLHttpRequest, status);
        $('#top #requested_answer_done').append( disp_string );
    };

    // call back function for updating my question's status
    function update_my_question(data){
        $('#top #my_question_inprogress').css( 'display', 'none' );
        $('#top #my_question_done').css( 'display', 'block' );
        $('#top #my_question_done').append( data );
    };
    // call back function for updating my question's status error handler
    function my_question_error( XMLHttpRequest, status, errorThrown ){
        $('#top #my_question_inprogress').css( 'display', 'none' );
        $('#top #my_question_done').css( 'display', 'block' );
        var disp_string = gf_getAjaxListErrorString( XMLHttpRequest, status);
        $('#top #my_question_done').append( disp_string );
    };

    // call back function for updating recent questions
    function update_recent_question(data){
        $('#top #recent_question_inprogress').css( 'display', 'none' );
        $('#top #recent_question_done').css( 'display', 'block' );
        $('#top #recent_question_done').append( data );
    }
    // call back function for updating recent questions error handler
    function recent_question_error( XMLHttpRequest, status, errorThrown ){
        $('#top #recent_question_inprogress').css( 'display', 'none' );
        $('#top #recent_question_done').css( 'display', 'block' );
        var disp_string = gf_getAjaxListErrorString( XMLHttpRequest, status);
        $('#top #recent_question_done').append( disp_string );
    };

    // call back function for updating useful questions
    function update_useful_question(data){
        $('#top #useful_question_inprogress').css( 'display', 'none' );
        $('#top #useful_question_done').css( 'display', 'block' );
        $('#top #useful_question_done').append( data );
    }
    // call back function for updating useful questions error handler
    function useful_question_error( XMLHttpRequest, status, errorThrown ){
        $('#top #useful_question_inprogress').css( 'display', 'none' );
        $('#top #useful_question_done').css( 'display', 'block' );
        var disp_string = gf_getAjaxListErrorString( XMLHttpRequest, status);
        $('#top #useful_question_done').append( disp_string );
    };

    // call back function for updating popular questions
    function update_popular_question(data){
        $('#top #popular_question_inprogress').css( 'display', 'none' );
        $('#top #popular_question_done').css( 'display', 'block' );
        $('#top #popular_question_done').append( data );
    }
    // call back function for updating popular questions error handler
    function popular_question_error( XMLHttpRequest, status, errorThrown ){
        $('#top #popular_question_inprogress').css( 'display', 'none' );
        $('#top #popular_question_done').css( 'display', 'block' );
        var disp_string = gf_getAjaxListErrorString( XMLHttpRequest, status);
        $('#top #popular_question_done').append( disp_string );
    };
});

// inactivate tab
function clear_tab( tab_name ) {
    is_alive = $('#top ' + tab_name + '_tab');
    if( is_alive == undefined && is_alive.length == 0 ) {
        return;
    }
    if($(tab_name + '_l').hasClass('tab_on_l')) {
        $(tab_name + '_l').removeClass('tab_on_l');
        $(tab_name + '_c').removeClass('tab_on_c');
        $(tab_name + '_r').removeClass('tab_on_r');
        $(tab_name + '_l').addClass('tab_off_l');
        $(tab_name + '_c').addClass('tab_off_c');
        $(tab_name + '_r').addClass('tab_off_r');
    }
};
// activate clicked tab
function activate_tab( tab_name ) {
    if($(tab_name + '_l').hasClass('tab_off_l')) {
        $(tab_name + '_l').removeClass('tab_off_l');
        $(tab_name + '_c').removeClass('tab_off_c');
        $(tab_name + '_r').removeClass('tab_off_r');
        $(tab_name + '_l').addClass('tab_on_l');
        $(tab_name + '_c').addClass('tab_on_c');
        $(tab_name + '_r').addClass('tab_on_r');
    }
}
// display client rect of active tab
function change_list(disp_id, tab_name){
    var disp1, disp2, disp3;
    switch (disp_id ) {
        case 1:
            disp1 = 'block';
            disp2 = 'none';
            disp3 = 'none';
            break;
        case 2:
            disp1 = 'none';
            disp2 = 'block';
            disp3 = 'none';
            break;
        case 3:
            disp1 = 'none';
            disp2 = 'none';
            disp3 = 'block';
            break;
        default:
            disp1 = 'none';
            disp2 = 'none';
            disp3 = 'block';
            break;
    }
    // have to change this function if the number of tabs changed
    $(tab_name + '_01').css( 'display', disp1 );
    $(tab_name + '_02').css( 'display', disp2 );
    $(tab_name + '_03').css( 'display', disp3 );
};
