//
// functions for FAQ WIDGETS
// don't forget to read common.js file before reading this source code.
//
//

function load_widget() {

    var base_url;
    base_url = $('#base_dir')[0].innerHTML + 'index.php';

    // get data counts to display
    $.ajax({
        url    : base_url + '?module=widget&action=ajax_dataCount',
        data   : 'json' ,
        timeout: 30000 ,
        success: wid_update_data_count ,
        error  : wid_datacount_error
    });

    // get category to display
    $.ajax({
        url    : base_url + '?module=widget&action=ajax_getCategory',
        timeout: 30000 ,
        success: wid_update_category ,
        error  : wid_category_error
    });

    // get ranking to display
    $.ajax({
        url    : base_url + '?module=widget&action=ajax_getRanking',
        timeout: 30000 ,
        success: wid_update_ranking ,
        error  : wid_ranking_error
    });

    // call back function for updating total question number
    function wid_update_data_count(data, status){
        var json_data = eval( '[' + data + ']');
        $('.widget #total_number_question')[0].innerHTML = 
            add_number_format( json_data[0]['question_number'] );
        $('.widget #avg_number_answer')[0].innerHTML = json_data[0]['avg_number'];
    };

    // call back function for updating total question number error handler
    function wid_datacount_error( XMLHttpRequest, status, errorThrown ){
        $('.widget #data_search_inprogress').css( 'display', 'none' );
        $('.widget #data_search_done').css( 'display', 'block' );
        $('.widget #total_number_question')[0].innerHTML = '---';
        $('.widget #avg_number_answer')[0].innerHTML = '---';
    };

    // add number format
    function add_number_format( value ) {
        var st_value = value.toString( 10 );
        if( st_value.length < 4 ){
            return value;
        }
        // reverse string
        reversed_value = st_value.split('').reverse().join('');
        var new_value = "";
        cnt_max = Math.floor( (st_value.length - 1) / 3 );
        // add comma every 3 chars
        for( cnt = 0; cnt < cnt_max; cnt++ ) {
            char_part = reversed_value.substr( cnt * 3, 3 );
            // add comma
            new_value += char_part + ',';
        }
        char_part = reversed_value.substr( cnt * 3 , 3 );
        new_value += char_part;

        // reverse string
        return new_value.split('').reverse().join('');
    }

    // call back function for updating category information
    function wid_update_category(data){
        $('.widget #category_search_inprogress').css( 'display', 'none' );
        $('.widget #category_info').append( data );
    };

    // call back function for updating category information error handler
    function wid_category_error( XMLHttpRequest, status, errorThrown ){
        $('.widget #category_search_inprogress').css( 'display', 'none' );
        var disp_string = gf_getAjaxErrorString( XMLHttpRequest, status );
        $('.widget #category_info').append( disp_string );
    };

    // call back function for updating ranking information
    function wid_update_ranking(data){
        $('.widget #ranking_inprogress').css( 'display', 'none' );
        $('.widget #ranking_info').append( data );
    };

    // call back function for updating ranking information error handler
    function wid_ranking_error( XMLHttpRequest, status, errorThrown ){
        $('.widget #ranking_inprogress').css( 'display', 'none' );
        var disp_string = gf_getAjaxErrorString( XMLHttpRequest, status );
        $('.widget #ranking_info').append( disp_string );
    };
}

function load_info_widget() {
    var base_url;
    base_url = $('#base_dir')[0].innerHTML + 'index.php';

    // get informations to display
    $.ajax({
        url    : base_url + '?module=widget&action=ajax_getInformation',
        timeout: 30000 ,
        success: wid_update_information ,
        error  : wid_information_error
    });

    // call back function for updating information
    function wid_update_information(data){
        $('#info_search_inprogress').css( 'display', 'none' );
        $('#info_search_done').append( data );
    };

    // call back function for updating information error handler
    function wid_information_error( XMLHttpRequest, status, errorThrown ){
        $('#info_search_inprogress').css( 'display', 'none' );
        var disp_string = gf_getAjaxErrorString( XMLHttpRequest, status );
        $('#info_search_done').append( disp_string );
    };
}

// get cookie info if user doesn't log in
function load_login_intial_data() {
    var base_url;
    base_url = $('#base_dir')[0].innerHTML + 'index.php';

    // get cookie info to display
    $.ajax({
        url    : base_url + '?module=widget&action=ajax_getLoginInfo',
        data   : 'json' ,
        timeout: 30000 ,
        success: wid_update_login ,
        error  : wid_login_error
    });

    // call back function for getting login cookies
    function wid_update_login(data){
        var json_data = eval( '[' + data + ']' );
        if( json_data[0]['loginid'] != '' ) {
            $('#login_widget input[name=loginid]').attr('value', json_data[0]['loginid']);
        }
        if( json_data[0]['email'] != '' ) {
            $('#login_widget input[name=email]').attr('value', json_data[0]['email']);
        }
        if( json_data[0]['pwd'] != '' ) {
            $('#login_widget input[name=pass]').attr( 'value', json_data[0]['pwd']);
        }
        if( json_data[0]['save'] ) {
            $('#login_widget input[name=auto]').attr('checked',true);
        }
        else {
            $('#login_widget input[name=auto]').attr('checked',false);
        }
    };

    // call back function for login error handler
    function wid_login_error( XMLHttpRequest, status, errorThrown ){
        $('#login_widget input[name=loginid]').attr('value', '' );
        $('#login_widget input[name=pass]').attr( 'value', '');
        $('#login_widget input[name=auto]').attr('checked',false);
    };
}


$(document).ready(function() {
    // check widget exist or not
    var is_exist = $('.widget');
    if( is_exist != undefined && is_exist.length != 0 ) {
        load_widget();
    }

    // check login widget exist or not
    is_exist = $('#login_widget');
    if( is_exist != undefined && is_exist.length != 0 ) {
        load_login_intial_data();
    }
    
    if ($.browser.msie && $.browser.version < 7) { // take away IE6
        $(document).bind('reveal.facebox', function() {
            var elems = document.getElementsByTagName("select");
            for (i = 0; i < elems.length; i++) {
                elems[i].className = "hidden";
            }
        });

        $(document).bind('close.facebox', function() {
            var elems = document.getElementsByTagName("select");
            for (i = 0; i < elems.length; i++) {
                elems[i].className = "select";
            }
        });
    }
});

