#!/bin/sh

PHPDIR="/usr/local/php/bin"

PATH=$PHPDIR:${PATH}:
export PATH

PHP_PATH=`which php`
export PHP_PATH
CONVERT_DIR='dnfaq/core/batch/actions/Convert'
export CONVERT_DIR

# check path
if [ -z ${PHP_PATH} ]; then
    echo "php path is not found."
    exit
fi

# check working directory
if [ -d dnfaq/js/ ]; then
    cd .
else
    echo "dnfaq/js is not found."
    exit
fi

#delete file or directory
if [ -d dnfaq/js/dojo ]; then
    rm -fr dnfaq/js/dojo
fi

if [ -d dnfaq/js/dojoset ]; then
    rm -fr dnfaq/js/dojoset
fi

if [ -d dnfaq/js/jq ]; then
    rm -fr dnfaq/js/jq
fi

# check working directory
if [ -d dnfaq/css/ ]; then
    cd .
else
    echo "dnfaq/css is not found."
    exit
fi

#delete file or directory
if [ -d dnfaq/css/dojo ]; then
    rm -fr dnfaq/css/dojo
fi

# check working directory
if [ -d dnfaq/t_p_s_license/ ]; then
    cd .
else
    echo "dnfaq/t_p_s_license is not found."
    exit
fi

#delete file or directory
if [ -f dnfaq/t_p_s_license/dojo_LICENSE.txt ]; then
    rm -f dnfaq/t_p_s_license/dojo_LICENSE.txt
fi

# check working directory
if [ -d dnfaq/core/webapp/ ]; then
    cd .
else
    echo "dnfaq/core/webapp is not found."
    exit
fi

#delete file or directory
if [ -f dnfaq/core/webapp/lib/MbDojoStringValidator.class.php ]; then
    rm -f dnfaq/core/webapp/lib/MbDojoStringValidator.class.php
fi

if [ -f dnfaq/core/webapp/modules/ans/actions/attaddAction.class.php ]; then
    rm -f dnfaq/core/webapp/modules/ans/actions/attaddAction.class.php
fi

if [ -f dnfaq/core/webapp/modules/ans/actions/attadddoAction.class.php ]; then
    rm -f dnfaq/core/webapp/modules/ans/actions/attadddoAction.class.php
fi

if [ -f dnfaq/core/webapp/modules/ans/actions/attdupAction.class.php ]; then
    rm -f dnfaq/core/webapp/modules/ans/actions/attdupAction.class.php
fi

if [ -f dnfaq/core/webapp/modules/ans/actions/attfixAction.class.php ]; then
    rm -f dnfaq/core/webapp/modules/ans/actions/attfixAction.class.php
fi

if [ -f dnfaq/core/webapp/modules/ans/actions/attresetAction.class.php ]; then
    rm -f dnfaq/core/webapp/modules/ans/actions/attresetAction.class.php
fi

if [ -f dnfaq/core/webapp/modules/ans/templates/attadd.html ]; then
    rm -f dnfaq/core/webapp/modules/ans/templates/attadd.html
fi

if [ -f dnfaq/core/webapp/modules/ans/templates/attdup.html ]; then
    rm -f dnfaq/core/webapp/modules/ans/templates/attdup.html
fi

if [ -f dnfaq/core/webapp/modules/ans/views/attaddView_success.class.php ]; then
    rm -f dnfaq/core/webapp/modules/ans/views/attaddView_success.class.php
fi

if [ -f dnfaq/core/webapp/modules/ans/views/attdupView_success.class.php ]; then
    rm -f dnfaq/core/webapp/modules/ans/views/attdupView_success.class.php
fi

if [ -d dnfaq/core/webapp/modules/dojo ]; then
    rm -fr dnfaq/core/webapp/modules/dojo
fi

if [ -f dnfaq/core/webapp/modules/que/actions/queattaddAction.class.php ]; then
    rm -f dnfaq/core/webapp/modules/que/actions/queattaddAction.class.php
fi

if [ -f dnfaq/core/webapp/modules/que/actions/queattadddoAction.class.php ]; then
    rm -f dnfaq/core/webapp/modules/que/actions/queattadddoAction.class.php
fi

if [ -f dnfaq/core/webapp/modules/que/actions/queattdupAction.class.php ]; then
    rm -f dnfaq/core/webapp/modules/que/actions/queattdupAction.class.php
fi

if [ -f dnfaq/core/webapp/modules/que/actions/queattfixAction.class.php ]; then
    rm -f dnfaq/core/webapp/modules/que/actions/queattfixAction.class.php
fi

if [ -f dnfaq/core/webapp/modules/que/actions/queattresetAction.class.php ]; then
    rm -f dnfaq/core/webapp/modules/que/actions/queattresetAction.class.php
fi

if [ -f dnfaq/core/webapp/modules/que/templates/queattadd.html ]; then
    rm -f dnfaq/core/webapp/modules/que/templates/queattadd.html
fi

if [ -f dnfaq/core/webapp/modules/que/templates/queattdup.html ]; then
    rm -f dnfaq/core/webapp/modules/que/templates/queattdup.html
fi

if [ -f dnfaq/core/webapp/modules/que/views/queattaddView_success.class.php ]; then
    rm -f dnfaq/core/webapp/modules/que/views/queattaddView_success.class.php
fi

if [ -f dnfaq/core/webapp/modules/que/views/queattdupView_success.class.php ]; then
    rm -f dnfaq/core/webapp/modules/que/views/queattdupView_success.class.php
fi

if [ -d dnfaq/core/webapp/tmp/templates_c ]; then
    rm -fr dnfaq/core/webapp/tmp/templates_c/*
fi

# upgrade
# check directory
if [ -d ${CONVERT_DIR} ]; then
    cd ${CONVERT_DIR}
else
    echo "${CONVERT_DIR} is not found."
    exit
fi

$PHP_PATH ./Update.php
if [ $? -ne 0 ]; then
    if [ -s ../../logs/Convert.log ]; then
        echo "Database table convert process error."
        cat ../../logs/Convert.log
    else
        echo "Database table convert execution error."
    fi

    exit
fi
